///////////////////////////////* DMA *//////////////////////////////////////////

typedef struct
{
    const volatile void *src;
    volatile void *dst;
    volatile unsigned int cnt;
} DMAREC;

#define DMA ((volatile DMAREC *) 0x040000B0)

#define REG_DMA0SAD         *(volatile u32*)0x40000B0  // source address
#define REG_DMA0DAD         *(volatile u32*)0x40000B4  // destination address
#define REG_DMA0CNT         *(volatile u32*)0x40000B8  // control register

// DMA channel 1 register definitions
#define REG_DMA1SAD         *(volatile u32*)0x40000BC  // source address
#define REG_DMA1DAD         *(volatile u32*)0x40000C0  // destination address
#define REG_DMA1CNT         *(volatile u32*)0x40000C4  // control register

// DMA channel 2 register definitions
#define REG_DMA2SAD         *(volatile u32*)0x40000C8  // source address
#define REG_DMA2DAD         *(volatile u32*)0x40000CC  // destination address
#define REG_DMA2CNT         *(volatile u32*)0x40000D0  // control register

// DMA channel 3 register definitions
#define REG_DMA3SAD         *(volatile u32*)0x40000D4   // source address
#define REG_DMA3DAD         *(volatile u32*)0x40000D8  // destination address
#define REG_DMA3CNT         *(volatile u32*)0x40000DC  // control register

// Defines
#define DMA_CHANNEL_0 0
#define DMA_CHANNEL_1 1
#define DMA_CHANNEL_2 2
#define DMA_CHANNEL_3 3

#define DMA_DESTINATION_INCREMENT (0 << 21)
#define DMA_DESTINATION_DECREMENT (1 << 21)
#define DMA_DESTINATION_FIXED (2 << 21)
#define DMA_DESTINATION_RESET (3 << 21)

#define DMA_SOURCE_INCREMENT (0 << 23)
#define DMA_SOURCE_DECREMENT (1 << 23)
#define DMA_SOURCE_FIXED (2 << 23)

#define DMA_REPEAT (1 << 25)

#define DMA_16 (0 << 26)
#define DMA_32 (1 << 26)

#define DMA_NOW (0 << 28)
#define DMA_AT_VBLANK (1 << 28)
#define DMA_AT_HBLANK (2 << 28)
#define DMA_AT_REFRESH (3 << 28)

#define DMA_IRQ (1 << 30)
#define DMA_ON (1 << 31)

#define START_ON_FIFO_EMPTY 0x30000000