typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

#define REG_DISPCTL *(unsigned short *)0x4000000

#define MODE3 3
#define BG2_ENABLE (1<<10)

/////////////////////////////////MODE4//////////////////////////////////////////
#define MODE4 4
#define BUFFER0 ((u16 *)0x6000000)
#define BUFFER1 ((u16 *)0x600A000)

#define BUFFER1FLAG (0x10)

#define PALETTE ((u16 *)0x5000000)

enum {REDIDX=240, GREENIDX, BLUEIDX, CYANIDX, MAGENTAIDX, YELLOWIDX, WHITEIDX, BLACKIDX};

////////////////////////////////////////////////////////////////////////////////

#define SCREENWIDTH 240
#define SCREENHEIGHT 160

#define OFFSET(r, c, numcols)  ((r)*(numcols)+(c))

extern unsigned short *videoBuffer;

////////////////////////////////COLOR///////////////////////////////////////////

#define COLOR(r,g,b) ((r) | (g)<<5 | (b)<<10)

#define RED COLOR(31,0,0)
#define BLUE COLOR(0,0,31)
#define GREEN COLOR(0,31,0)
#define CYAN COLOR(0,31,31)
#define MAGENTA COLOR(31,0,31)
#define YELLOW COLOR(31,31,0)
#define BLACK 0
#define WHITE COLOR(31,31,31)

#define SCANLINECOUNTER *(volatile u16 *)0x4000006

//////////////////////////////BRICK STRUCT//////////////////////////////////////

typedef struct brick {

    int row;
    int oldrow;
    int rdel;
    int col;
    int oldcol;
    int cdel;
    int size;

} b;

////////////////////////////FUNCTION PROTOTYPES/////////////////////////////////

void setPixel4(int row, int col, u8 index);
void drawRect(int row, int col, int height, int width, u8 index);
void drawHorizLine(int row, int col, int length, u8 color);
void drawVertLine(int row, int col, int length, u8 color);
void drawHollowRect(int row, int col, int height, int width, int thickness, u8 color);
void rasterCircle(int row, int col, int radius, u8 color);
void rasterCircleFace(int row, int col, int radius, u8 color);
void drawStar(int row, int col, int rc, u8 color);
void grid();
u16 changeColor();
void clrscr();
void waitForVblank();
void pause();
void FlipPage();